<%-- $Id: list_biowells.jsp 8153 2023-06-05 12:48:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.snapshot.AnnotationLoaderUtil"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.units.UnitUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.clients.web.util.ProjectSpecificInfoFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOWELL;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int bioPlateId = Values.getInt(request.getParameter("bioplate_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("biowell", "biowells");
final DbControl dc = sc.newDbControl(":List "+itemType);
ItemResultIterator<BioWell> biowells = null;
List<AnnotationLoaderUtil> annotationLoaders = new ArrayList<AnnotationLoaderUtil>();

Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);

WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);

try
{
	final BioPlate bioplate = BioPlate.getById(dc, bioPlateId);
	final BioPlateType bioPlateType = bioplate.getBioPlateType();
	final boolean createPermission = bioplate.hasPermission(Permission.WRITE);
	final boolean deletePermission = createPermission;
	final BioWell.LockMode lockMode = bioPlateType.getLockMode();
	final Item bioMaterialType = bioPlateType.getBioMaterialType();

	Enumeration<String, String> rows = new Enumeration<String,String>();
	for (int r = 0; r < bioplate.getPlateGeometry().getRows() && r < 256; r++)
	{
		rows.add(Integer.toString(r), rowFormatter.format(r));
	}
	
	Enumeration<String, String> columns = new Enumeration<String,String>();
	for (int c = 0; c < bioplate.getPlateGeometry().getColumns() && c < 256; c++)
	{
		columns.add(Integer.toString(c), columnFormatter.format(c));
	}
	
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	Formatter<Number> numericFormatter = FormatterFactory.getNumberFormatter(sc);
	Unit microGram = UnitUtil.getUnit(dc, Quantity.MASS, "µg");

	SnapshotManager manager = new SnapshotManager();
	ProjectSpecificInfoFilter psInfo = new ProjectSpecificInfoFilter();
	if (bioMaterialType != null)
	{
		final ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(bioMaterialType);
		for (AnnotationType at : annotationTypeQuery.list(dc))
		{
			annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at));
		}
	}

	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioplate);
	try
	{
		final ItemQuery<BioWell> query = Base.getConfiguredQuery(dc, cc, jspContext, true, bioplate.getBioWells(), mode);
		query.join(Hql.leftJoin(null, "bioMaterial", "mbm", null, true));
		query.join(Hql.leftJoin("mbm", "creationEvent", "evt", null, true));
		query.join(Hql.leftJoin("mbm", "owner", "usr", null, false));
		query.join(Hql.leftJoin("evt", "protocol", "pcl", null, false));
		if (!"row".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("row")));
		if (!"column".equals(cc.getSortProperty())) query.order(Orders.asc(Hql.property("column")));
		biowells = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	ExtensionsInvoker<ButtonAction> invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker<ListColumnAction<BioWell,?>> columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>" id="list-page">
	<base:head scripts="table.js,tabcontrol-2.js,~biowells.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<%
		if (!mode.isSelectionMode())
		{
			%>
			<p:path><p:pathelement 
				title="Bioplates" href="<%="../index.jsp?ID="+ID%>" 
				/><p:pathelement title="<%=HTML.encodeTags(bioplate.getName())%>" 
				/></p:path>
			<%
		}
		else
		{
			%>
			<h1><%=title%></h1>
			<%
		}
		%>
		<t:tabcontrol 
			id="main"
			subclass="content mastertabcontrol"
			active="biowells" 
			notabs="<%=mode.isSelectionMode()%>"
			>
		<t:tab id="properties" title="Properties" />
		<t:tab id="annotations" title="Annotations" />				
		<t:tab id="biowells" title="Wells">
		<tbl:table 
			id="biowells" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			filterrows="<%=cc.getFilterRows()%>"
			subclass="fulltable"
			stickyheaders="<%=cc.getSetting("columns.sticky", null)%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="bioplate_id" 
				value="<%=String.valueOf(bioPlateId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="row"
				property="row"
				datatype="int"
				title="Row"
				sortable="true" 
				filterable="true"
				enumeration="<%=rows%>"
				exportable="true"
				show="always" 
				formatter="<%=rowFormatter%>"
			/>
			<tbl:columndef 
				id="column"
				property="column"
				datatype="int"
				title="Column"
				sortable="true" 
				filterable="true"
				enumeration="<%=columns%>"
				exportable="true"
				show="always" 
				formatter="<%=columnFormatter%>"
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>	
			<tbl:columndef 
				id="bioMaterial.name"
				property="$mbm.name"
				exportproperty="bioMaterial.name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="bioMaterial.externalId"
				property="$mbm.externalId"
				exportproperty="bioMaterial.externalId"
				datatype="string"
				title="External id"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>			
			<tbl:columndef 
				id="bioMaterial.originalQuantity"
				property="$mbm.originalQuantity"
				exportproperty="bioMaterial.originalQuantity"
				datatype="float"
				title="Original quantity (µg)"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=microGram%>"
				formatter="<%=numericFormatter%>"
			/>
			<tbl:columndef 
				id="bioMaterial.remainingQuantity"
				property="$mbm.remainingQuantity"
				exportproperty="bioMaterial.remainingQuantity"
				datatype="float"
				title="Remaining quantity (µg)"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=microGram%>"
				formatter="<%=numericFormatter%>"
			/>
			<tbl:columndef 
				id="bioMaterial.protocol"
				property="$evt.protocol"
				sortproperty="$pcl.name"
				filterproperty="$pcl.name"
				exportproperty="bioMaterial.creationEvent.protocol.name"
				datatype="string"
				title="Protocol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="bioMaterial.entryDate"
				property="$evt.entryDate"
				exportproperty="bioMaterial.creationEvent.entryDate"
				datatype="date"
				title="Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="bioMaterial.eventDate"
				property="$evt.eventDate"
				exportproperty="bioMaterial.creationEvent.eventDate"
				datatype="date"
				title="Created"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="bioMaterial.owner"
				property="$usr.name"
				exportproperty="bioMaterial.owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="bioMaterial.description"
				property="$mbm.description"
				exportproperty="bioMaterial.description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef
				id="itemList"
				property="$mbm.§itemLists"
				datatype="int"
				title="Item list"
				filterable="true"
				enumeration="<%=Base.getItemListsEnum(dc, bioMaterialType, cc.getInclude())%>"
			/>
			<tbl:columndef 
				id="originalBioMaterial.name"
				property="originalBioMaterial.name"
				datatype="string"
				title="Original biomaterial"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<%
			for (AnnotationLoaderUtil loader : annotationLoaders)
			{
				AnnotationType at = loader.getAnnotationType();
				Enumeration<String, String> annotationEnum = null;
				Formatter<Object> formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					if (!at.getDisplayAsList()) annotationEnum.add("", "-none-");
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%="at"+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+" [A]"%>" 
					property="<%="$mbm.#"+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1%>" 
					filterable="true" 
					exportable="false"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			%>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar
					visible="<%=mode.hasToolbar()%>"
					subclass="bottomborder"
					>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=biowells == null ? 0 : biowells.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header clazz="row-index bg-filled-100" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<%
					int numFilters = cc.getNumPropertyFilters();
					int numRows = cc.getFilterRows();
					for (int filterNo = 0; filterNo < numRows; filterNo++)
					{
						boolean lastRow = filterNo == numRows-1;
						%>
						<tbl:headerrow>
							<tbl:header subclass="row-index bg-filled-100">
								<div class="index-<%=mode.getName()%>">
									<div class="index"></div>
									<div class="check">
										<base:icon 
											subclass="link table-check"
											image="check_uncheck.png" 
											tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
											visible="<%=lastRow && mode.hasCheck()%>"
										/>
									</div>
									<div class="icons">
										<base:icon
											subclass="link table-filter-row-action"
											image="add.png"
											tooltip="Add extra filter row"
											visible="<%=lastRow%>"
										/><base:icon
											subclass="link table-filter-row-action"
											image="remove.png"
											tooltip="Remove this filter row"
											visible="<%=numRows > 1 || numFilters > 0 %>"
											data-remove-row="<%=filterNo%>"
										/>
									</div>
								</div>
							</tbl:header>
							<tbl:propertyfilter row="<%=filterNo%>" />
						</tbl:headerrow>
						<%
					}
					%>
					<tbl:columnsubtitles />
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (biowells != null)
					{						
						while (biowells.hasNext())
						{
							BioWell item = biowells.next();
							int itemId = item.getId();
							String coordinate = rowFormatter.format(item.getRow()) + columnFormatter.format(item.getColumn());
							index++;
							numListed++;
							MeasuredBioMaterial bioMaterial = null;
							BioMaterialEvent creationEvent = null;
							boolean editWellPermission = item.hasPermission(Permission.USE);
							try
							{
								bioMaterial = item.getBioMaterial();
								if (bioMaterial != null)
								{
									creationEvent = bioMaterial.getCreationEvent();
									editWellPermission &= bioMaterial.hasPermission(Permission.WRITE) && !bioMaterial.isLockedInWell();
								}
								else
								{
									editWellPermission &= item.canAddBioMaterial();
								}
							}
							catch (PermissionDeniedException ex)
							{
								editWellPermission = false;
							}
							%>
							<tbl:row>
								<tbl:header clazz="row-index bg-filled-100">
									<div class="index-<%=mode.getName()%>">
										<div class="index <%=index>999?"index-smaller":""%>"><%=index%></div>
										<div class="check">
											<base:input
												type="checkbox" 
												name="<%=itemId%>" 
												value="<%=itemId%>" 
												title="<%=coordinate%>" 
												checked="<%=cc.getSelected().contains(itemId)%>"
												visible="<%=mode.hasCheck()%>"
											/>
											<base:input 
												type="radio" 
												name="item_id" 
												value="<%=itemId%>" 
												title="<%=coordinate%>" 
												checked="<%=selectedItemId == itemId%>"
												visible="<%=mode.hasRadio()%>"
											/>
										</div>
										<div class="icons">
										</div>
									</div>
								</tbl:header>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="row">
									<%
									if (mode.isSelectionMode())
									{
										%>
										<div 
											class="link table-item"
											data-item-id="<%=itemId%>"
											tabindex="0"
											title="Select this item">
											<tbl:cellvalue value="<%=item.getRow()%>" />
										</div>
									<%
									}
									else
									{
										%><tbl:cellvalue value="<%=item.getRow()%>" /><%
									}
									%>
								</tbl:cell>
								<tbl:cell column="column" value="<%=item.getColumn()%>" />
								<tbl:cell column="bioMaterial.name">
									<base:propertyvalue 
											item="<%=item%>" 
											property="bioMaterial"
											enableEditLink="<%=mode.hasEditLink()%>" 
											enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/>
									<base:icon 
										visible="<%=editWellPermission%>"
										subclass="link auto-init"
										data-auto-init="item-link" 
										data-item-type="BIOWELL" 
										data-item-id="<%=itemId %>"
										image="edit.png"
										tooltip="<%=bioMaterial == null ? "Add biomaterial to this well" : "Change the biomaterial in this well"%>"
									/>
									<base:icon 
										visible="<%=!editWellPermission%>"
										image="locked.png"
										tooltip="<%=item.hasBeenUsed() ? "This well has already been used" : "This well is locked for modification"%>"
									/>
								</tbl:cell>
								<tbl:cell column="bioMaterial.owner"
									><base:propertyvalue 
										item="<%=bioMaterial%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"	
									/></tbl:cell>
								<tbl:cell column="bioMaterial.description"><base:propertyvalue item="<%=bioMaterial%>" property="description"/></tbl:cell>
								<tbl:cell column="bioMaterial.protocol"><base:propertyvalue item="<%=creationEvent%>" property="protocol"/></tbl:cell>
								<tbl:cell column="bioMaterial.entryDate" value="<%=creationEvent == null ? null : creationEvent.getEntryDate() %>" />
								<tbl:cell column="bioMaterial.eventDate" value="<%=creationEvent == null ? null : creationEvent.getEntryDate() %>" />
								<tbl:cell column="bioMaterial.externalId"><%=HTML.encodeTags(bioMaterial == null ? null : bioMaterial.getExternalId())%></tbl:cell>								
								<tbl:cell column="bioMaterial.originalQuantity" value="<%=bioMaterial == null ? null : bioMaterial.getOriginalQuantity()%>" />
								<tbl:cell column="bioMaterial.remainingQuantity" value="<%=bioMaterial == null ? null : bioMaterial.getRemainingQuantity()%>" />
								<tbl:cell column="originalBioMaterial.name"><base:propertyvalue item="<%=item%>" property="originalBioMaterial" /></tbl:cell>
								<%
								if (bioMaterial != null && bioMaterial.isAnnotated())
								{
									AnnotationSetSnapshot snapshot = manager.getSnapshot(dc, bioMaterial.getAnnotationSet().getId());
									for (AnnotationLoaderUtil loader : annotationLoaders)
									{
										%>
										<tbl:cell 
											column="<%="at"+loader.getId()%>"
											><%
											if (loader.find(snapshot, psInfo.reset())) 
											{
												%><tbl:cellvalue 
													list="<%=loader.getValues()%>"
													bulletlist="<%=loader.useBulletList() %>"
													suffix="<%=loader.getUnitSymbol()%>"
													clazz="<%=psInfo.hasProjectSpecificAnnotation() ? "ps-annotation" : null%>"
												/><%
											}
											%></tbl:cell>
										<%
									}
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
						}
					}
					if (numListed == 0)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer note">
								<%=biowells == null || biowells.getTotalCount() == 0 ? "No biowells were found" : "No biowells on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</t:tab>
		
		<t:tab id="events" title="Plate events" />
		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items" />
		<t:tab id="history" title="History"
			tooltip="Displays a log with the history of this item"
			visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>" />
		</t:tabcontrol>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (biowells != null) biowells.close();
	if (dc != null) dc.close();
}
%>