<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BioPlateEventType"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Kit"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final int sourcePlateId = Values.getInt(request.getParameter("sourceplate_id"));
final ItemContext cc = sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.MOVE);
final DbControl dc = sc.newDbControl(":Move biomaterial wizard");
try
{
	BioPlate sourcePlate = BioPlate.getById(dc, sourcePlateId);
	
	// Load recently used items
	List<Hardware> recentHardware = cc.getRecent(dc, Item.HARDWARE);
	List<Protocol> recentProtocols = cc.getRecent(dc, Item.PROTOCOL);
	List<Kit> recentKits = cc.getRecent(dc, Item.KIT);
	
	Item itemType = null;
	try
	{
		itemType = sourcePlate.getBioPlateType().getBioMaterialType();
	}
	catch (PermissionDeniedException ex)
	{}
	// Find a common itemsubtype (if any)
	ItemSubtype commonSubtype = null;
	boolean first = true;
	for (BioWell well : sourcePlate.getBioWells().list(dc))
	{
		try
		{
			if (!well.isEmpty())
			{
				ItemSubtype subtype = well.getBioMaterial().getItemSubtype();
				if (first)
				{
					commonSubtype = subtype;
					first = false;
				}
				else
				{
					if (subtype == null || !subtype.equals(commonSubtype))
					{
						commonSubtype = null;
						break;
					}
				}
			}
		}
		catch (PermissionDeniedException ex)
		{}
	}
	if (commonSubtype != null && itemType == null)
	{
		itemType = commonSubtype.getMainItemType();
	}
	ItemSubtype protocolType = null;
	ItemSubtype hardwareType = null;
	ItemSubtype kitType = null;
	if (commonSubtype != null)
	{
		protocolType = commonSubtype.getRelatedSubtype(Item.PROTOCOL);
		hardwareType = commonSubtype.getRelatedSubtype(Item.HARDWARE);
		kitType = commonSubtype.getRelatedSubtype(Item.KIT);
	}
	
	final Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	final String dateFormat = FormatterSettings.getDateFormat(sc);
	final String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	final String htmlDateFormat = HTML.encodeTags(dateFormat);
	final boolean showSourceCoordinates = Values.getBoolean(sc.getUserClientSetting("move-biomaterial.show-source-coordinates"), true);
	%>
	<base:page type="popup" title="Move biomaterial">
	<base:head scripts="plate.js,js-draw.js,~wizards.js,~move_biomaterial.js" styles="plate.css,toolbar.css" />
	<base:body>
		<div id="canvas" style="position: absolute; z-index: 99;"></div>
		<h1>Move biomaterial to plate <base:help helpid="bioplateevent.move" /></h1>
		
		<div id="page-data" class="datacontainer"
			data-protocol-type="<%=protocolType != null ? protocolType.getId() : 0 %>"
			data-hardware-type="<%=hardwareType != null ? hardwareType.getId() : 0 %>"
			data-kit-type="<%=kitType != null ? kitType.getId() : 0 %>"
			data-biomaterial-type="<%=itemType != null ? itemType.getValue() : 0 %>"
			data-common-subtype="<%=commonSubtype != null ? commonSubtype.getId() : 0 %>"
			data-source-plate="<%=sourcePlateId%>"
		></div>
		
		<form name="main" action="index.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="MoveBioMaterial">
		<input type="hidden" name="sourceplate_id" value="<%=sourcePlateId%>">
		<input type="hidden" name="destplate_id" value="">
		<input type="hidden" name="rows" value="">
		<input type="hidden" name="columns" value="">	
		
		<div class="content" >
			<div class="absolutefull" style="height: 12em;">
				<div class="absolutefull" style="width: 50%; bottom: 2em;">
					<table class="fullform input100 smaller">
					<tr>
						<th>Event name</th>
						<td><input class="text required" type="text" name="name" 
							value="Move biomaterial" 
							maxlength="<%=BioPlateEvent.MAX_NAME_LENGTH%>"></td>
					</tr>
					<tr>
						<th>Event date</th>
						<td>
							<input class="text" type="text" name="event_date" id="event_date" style="width: 15em;"
								value="<%=HTML.encodeTags(dateFormatter.format(new Date()))%>" 
								maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
							<base:calendar textarea="event_date" title="Event date" />
						</td>
					</tr>
					<tr>
						<th>Protocol</th>
						<td>
							<base:select 
								id="protocol_id"
								clazz="selectionlist"
								required="false"
								current="<%=null%>"
								recent="<%=recentProtocols%>"
							/>
						</td>
					</tr>
					<tr>
						<th>Kit</th>
						<td>
							<base:select 
								id="kit_id"
								clazz="selectionlist"
								required="false"
								current="<%=null%>"
								recent="<%=recentKits%>"
							/>
						</td>
					</tr>
					<tr>
						<th>Hardware</th>
						<td>
							<base:select 
								id="hardware_id"
								clazz="selectionlist"
								required="false"
								current="<%=null%>"
								recent="<%=recentHardware%>"
							/>
						</td>
					</tr>
					</table>
				</div>
				<div class="absolutefull" style="left: 50%; width: 50%;">
					<table style="width: 100%;">
					<tr>
						<td><b>Description</b><br>
							<textarea class="text" rows="4" name="description" id="description" style="width: calc(100% - 10px);"
							></textarea></td>
						<td style="width: 20px;">
							<base:zoom textarea="description" title="Description" />
						</td>
					</tr>
					</table>
				</div>
				<div class="absolutefull" style="top: auto; height: 2em;">
					<tbl:toolbar id="toolbar.mappings" subclass="topborder bottomborder bg-filled-50" style="height: 100%;">
						<tbl:button 
							id="btnSelectPlate"
							title="Select plate&hellip;" 
							image="move_to_plate.png" 
							tooltip="Select the destination plate"
						/>
						<tbl:button 
							id="btnClearMapping"
							title="Clear" 
							image="cancel.png" 
							tooltip="Clear all mapped wells"
						/>
						<tbl:button 
							id="btnPlaceByRow"
							title="Place by row" 
							image="place_by_row.png" 
							tooltip="Place remaining items; start with rows"
						/>
						<tbl:button 
							id="btnPlaceByColumn"
							title="Place by column" 
							image="place_by_column.png" 
							tooltip="Place remaining items; start with columns"
						/>
						<tbl:button 
							id="btnSelectPlateMapping"
							title="Predefined mapping&hellip;" 
							image="star.png" 
							tooltip="Select a predefined plate mapping"
						/>
					</tbl:toolbar>
				</div>
			</div>
			<div class="absolutefull bottomborder" style="top: 12em;">
				<div class="absolutefull" style="width: 50%;">
					<div class="absolutefull bg-filled-100" style="height: 2em;">
						<div class="padded">
						<b>Source plate:</b> <span id="plate.src.name"></span>
						<%=commonSubtype != null ? "<span class=\"itemsubtype\">[" + HTML.encodeTags(commonSubtype.getName()) + "]</span>" : "" %>
						</div>
					</div>
					
					<div class="absolutefull topborder" style="top: 2em;">
						<table style="margin: auto; height: 100%;"><tr><td>
							<div id="plate.src"></div>
							<br>
						</td></tr></table>
					</div>
					
				</div>
				<div class="absolutefull" style="left: auto; width: 50%;">
					<div class="absolutefull bg-filled-100" style="height: 2em;">
						<div class="padded">
						<b>Destination plate:</b> <span id="plate.dest.name" tabindex="0"><i>not selected</i></span>
						</div>
					</div>
						
					<div class="absolutefull leftborder topborder" style="top: 2em;">
						<table style="margin: auto; height: 100%;"><tr><td>
							<div id="plate.dest"></div>
							<div id="plate.dest.options" style="display: none;">
								<input type="checkbox" name="showSourceCoordinates" id="showSourceCoordinates"
								<%=showSourceCoordinates ? "checked" : ""%> value="1"
								><label for="showSourceCoordinates">Show source coordinates</label>
							</div>
						</td></tr></table>
					</div>
				</div>

			</div>
		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>