<%-- $Id: save_preset.jsp 7957 2021-06-03 07:39:33Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Ask for confirmation to delete a preset.


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final String columns = request.getParameter("columns");
final String settingName = Values.getString(request.getParameter("settingName"), "columns");
final String stickyColumn = Values.getStringOrNull(request.getParameter("stickyColumn"));
%>
<base:page type="popup" title="Save preset">
<base:head scripts="~save_preset.js" />
<base:body>
	<h1>Save preset <base:help helpid="columns.configure.saveas" /></h1>

	<form name="preset" action="submit_preset.jsp" method="post">
	<input type="hidden" name="ID" value="<%=ID%>">
	<input type="hidden" name="cmd" value="Save">
	<input type="hidden" name="columns" value="<%=HTML.encodeTags(columns)%>">
	<input type="hidden" name="item_type" value="<%=itemType.name()%>">
	<input type="hidden" name="subcontext" value="<%=subContext%>">
	<input type="hidden" name="settingName" value="<%=settingName%>">
	<%
	if (stickyColumn != null)
	{
		%>
		<input type="hidden" name="stickyColumn" value="<%=HTML.encodeTags(stickyColumn)%>">
		<%
	}
	%>
	<div class="content">
		<table class="fullform input100 smaller bottomborder">
		<tr>
			<th>Name</th>
			<td><input class="text required auto-init" data-auto-init="focus" 
				type="text" name="name" value="" maxlength="40"></td>
		</tr>
		<tr class="dynamic">
			<th></th>
			<td></td>
		</tr>
		</table>
	</div>
	</form>

	<div class="legend">
		<base:icon image="required.png" />= required information
	</div>

	<base:buttongroup subclass="dialogbuttons">
		<base:button id="btnSave" title="Ok" />
		<base:button id="close" title="Cancel" />
	</base:buttongroup>

</base:body>
</base:page>
